// MyActiveXCtrl.cpp : Implementation of the CMyActiveXCtrl ActiveX Control class.

#include "stdafx.h"
#include "MyActiveX.h"
#include "MyActiveXCtrl.h"
#include "MyActiveXPropPage.h"


#include <ws2tcpip.h>
#include <tchar.h>
#include <stdio.h>
#include "exports.h"
#include <io.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(CMyActiveXCtrl, COleControl)



// Message map

BEGIN_MESSAGE_MAP(CMyActiveXCtrl, COleControl)
	ON_MESSAGE(OCM_COMMAND, &CMyActiveXCtrl::OnOcmCommand)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()



// Dispatch map

BEGIN_DISPATCH_MAP(CMyActiveXCtrl, COleControl)
END_DISPATCH_MAP()



// Event map

BEGIN_EVENT_MAP(CMyActiveXCtrl, COleControl)
END_EVENT_MAP()



// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CMyActiveXCtrl, 1)
	PROPPAGEID(CMyActiveXPropPage::guid)
END_PROPPAGEIDS(CMyActiveXCtrl)



// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CMyActiveXCtrl, "MYACTIVEX.MyActiveXCtrl.1",
	0x47b8daf0, 0xcfb4, 0x4ee6, 0x8d, 0xee, 0x9f, 0xb1, 0x30, 0x4d, 0x76, 0x11)



// Type library ID and version

IMPLEMENT_OLETYPELIB(CMyActiveXCtrl, _tlid, _wVerMajor, _wVerMinor)



// Interface IDs

const IID BASED_CODE IID_DMyActiveX =
		{ 0xF229936E, 0xD83E, 0x4448, { 0xA9, 0xA, 0x55, 0xA2, 0xD7, 0x88, 0xF4, 0xDC } };
const IID BASED_CODE IID_DMyActiveXEvents =
		{ 0x7F7E7709, 0x500E, 0x4D57, { 0xA4, 0xC8, 0xA0, 0x42, 0x62, 0x21, 0xE8, 0xC7 } };



// Control type information

static const DWORD BASED_CODE _dwMyActiveXOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CMyActiveXCtrl, IDS_MYACTIVEX, _dwMyActiveXOleMisc)



// CMyActiveXCtrl::CMyActiveXCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CMyActiveXCtrl

BOOL CMyActiveXCtrl::CMyActiveXCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_MYACTIVEX,
			IDB_MYACTIVEX,
			afxRegApartmentThreading,
			_dwMyActiveXOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}



// CMyActiveXCtrl::CMyActiveXCtrl - Constructor



// CMyActiveXCtrl::~CMyActiveXCtrl - Destructor

CMyActiveXCtrl::~CMyActiveXCtrl()
{
	// TODO: Cleanup your control's instance data here.
}





FILE *f;


//  ErrorMessage support function.
//  Retrieves the system error message for the GetLastError() code.
//  Note: caller must use LocalFree() on the returned LPCTSTR buffer.
LPCTSTR ErrorMessage(DWORD error) 
{ 
    LPVOID lpMsgBuf;

    FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER 
                   | FORMAT_MESSAGE_FROM_SYSTEM 
                   | FORMAT_MESSAGE_IGNORE_INSERTS,
                  NULL,
                  error,
                  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                  (LPTSTR) &lpMsgBuf,
                  0,
                  NULL);

    return((LPCTSTR)lpMsgBuf);
}

//  PrintError support function.
//  Simple wrapper function for error output.
DWORD PrintError(char * errDesc)
{
	DWORD errID = GetLastError();
    LPCTSTR errMsg = ErrorMessage(errID);
	fprintf(f, "%s:\n\t** ERROR [0x%08X]**  %s\n", errDesc, errID, errMsg);
//	_tprintf(TEXT("%s:\n\t** ERROR [0x%08X]**  %s\n"), errDesc, errID, errMsg);
    LocalFree((LPVOID)errMsg);

	return errID;
}

void PrintReg(char *good){
	fprintf(f, "%s", good);
	fflush(f);
}


/*
void PrintErrorByCode(char * errDesc, DWORD SysErrCode)
{
	LPCTSTR errMsg = ErrorMessage(SysErrCode);
    _tprintf(TEXT("%s:\n\t** ERROR [0x%08X]**  %s\n"), errDesc,SysErrCode, errMsg);
    LocalFree((LPVOID)errMsg);
}
*/


void Run(HANDLE log) {
	TestFileSystem(log);
	TestRegistry(log);
	TestNetworkListen(log);
	TestNetworkReadWrite(log);
	TestSpyScreen(log);
	TestSpyKeys(log);
	TestThreads(log);
	TestProcesses(log);
	TestGetHandle(log);
//	TestChrisTests(log);
}


#define OUTPUT L"%USERPROFILE%\\AppData\\LocalLow\\output.txt"


void charlie()
{
//	f = fopen("C:\\Users\\Charlie\\Desktop\\foo.txt", "w+");
//	fwrite("hi", 1, 2, f);
//	fclose(f);
//	int chandle = _fileno(f);
//	HANDLE pipe = (HANDLE) _get_osfhandle(chandle);


/*
      Beep(1000,100);
	WCHAR path_expanded[MAX_PATH] = {0};
	DWORD size = ExpandEnvironmentStringsW(OUTPUT, path_expanded, MAX_PATH-1);
	if(!size)
	{
		printf("[ERROR] Could not expand %ls\r\n", OUTPUT);
foo:		goto foo;
	}
    HANDLE pipe = ::CreateFile(path_expanded, 
							   GENERIC_WRITE,
                               FILE_SHARE_READ | FILE_SHARE_WRITE,
                               NULL,  // Default security attributes.
                               CREATE_ALWAYS,
                               FILE_ATTRIBUTE_NORMAL,
                               NULL);  // No template

    if (INVALID_HANDLE_VALUE == pipe) {

		printf("[ERROR] Could not open %ls\r\n", OUTPUT);
bar: goto bar;
	  exit(1);
    }
*/
//	Run(pipe);

	/*
	//Test 1,2 
	WCHAR wszSystemDirFile[MAX_PATH] = L"C:\\Windows\\System32\\ntdll.dll";
	WCHAR wszSystemDirFile_Write[MAX_PATH] = L"C:\\Windows\\System32\\fake.dll";
	HANDLE hFile = INVALID_HANDLE_VALUE;
	DWORD dwBytesWritten = 0;

	//Test 1: Read system directory file
	hFile = CreateFileW(wszSystemDirFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);  
	if (hFile == INVALID_HANDLE_VALUE)
	{
		PrintError("[!] System Directory File Read Failed");
	}
	else
	{
		PrintReg("[*] Open System Directory Read PASSED!\n");
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

	//Test 2: Write system directory file
	hFile = CreateFileW(wszSystemDirFile_Write, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		PrintError("[!] System Directory File Write Failed");
	}
	else 
	{
		memset(buff, 0x0, sizeof(buff));
		wcsncpy_s(buff, sizeof(buff) / 2, L"DEADBEEF", (sizeof(buff) / 2) - 1);
		WriteFile(hFile, buff, sizeof(buff), &dwBytesWritten, NULL);
		PrintReg("[*] Open System Directory Write PASSED!\n");
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

	//Test 3: Create a process (report Integrity level)
	STARTUPINFOW si;
	PROCESS_INFORMATION pi;
	WCHAR wszProcess_Sys[MAX_PATH] = L"C:\\Windows\\System32\\cmd.exe";
	//WCHAR wszProcess_Sys[MAX_PATH] = L"C:\\Users\\chris\\Desktop\\cmd.exe";  //XXX Potentially start a non-systemdir process?
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	ZeroMemory(&pi, sizeof(pi));
	if (!CreateProcessW(NULL, wszProcess_Sys, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
	{
		PrintError("[!] Create Process Failed");
	}
	else
	{
		PrintReg("[*] Create Process PASSED!\n");
		if(!TerminateProcess(pi.hProcess, 0))
		{
			PrintError("!!! Terminate Process Failed!");
			exit(1);
		}
	}

	////Test 4: Create/Read/Write/Listen from a Socket
	WSADATA wsaData;
	struct addrinfo *result = NULL, *ptr = NULL;
	struct addrinfo hints;
	int iResult;
	SOCKET ConnectSocket = INVALID_SOCKET;
	char *sendbuf = "GET / HTTP/1.1\r\nHost: illmatics.com\r\n\r\n";
	char recvbuf[1024];
	BOOL send_passed = false;
	BOOL recv_passed = false;
	BOOL listen_passed = false;
	BOOL proceed = false;

	//Listen socket
	SOCKET ListenSocket = INVALID_SOCKET;
	sockaddr_in service;

	ZeroMemory(&hints, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;

	iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if (iResult != 0)
	{
		PrintError("WSAStart failed: %d\n");
	}
	else
	{
		proceed = true;
	}

	if(proceed)
	{
		iResult = getaddrinfo("illmatics.com", "80", &hints, &result);
		if (iResult != 0)
		{
			PrintError("getaddrinfo faild: %d\n");
			proceed = false;
		}
		else
		{
			proceed = true;
		}
	}

	//attempt to get the first address returned
	ptr = result;

	if(proceed)
	{
		ConnectSocket = socket(ptr->ai_family, ptr->ai_socktype, ptr->ai_protocol);
		if(ConnectSocket == INVALID_SOCKET)
		{
			PrintError("Error at socket(): %ld\n");
			freeaddrinfo(result);
			proceed = false;
		}
		else
		{
			proceed = true;
		}
	}

	if(proceed)
	{
		iResult = connect(ConnectSocket, ptr->ai_addr, (int)ptr->ai_addrlen);
		if(iResult == SOCKET_ERROR) 
		{
			closesocket(ConnectSocket);
			ConnectSocket = INVALID_SOCKET;
			proceed = false;
		}
		else
		{
			proceed = true;
		}
	}

	if(proceed)
	{
		iResult = send(ConnectSocket, sendbuf, (int)strlen(sendbuf), 0);
		if(iResult == SOCKET_ERROR)
		{
			PrintError("send() failure: %d\n");
			proceed = false;	
		}
		else
		{
			proceed = true;
			send_passed = true;
		}
	}

	if(send_passed)
	{
		PrintReg("[*] WSASocket send() PASSED!\n");
	}
	else
	{
		PrintError("[!] WSASocket send() Failed");
	}

	if(proceed)
	{
		ZeroMemory(&recvbuf, sizeof(recvbuf));
		iResult = recv(ConnectSocket, recvbuf, (int)sizeof(recvbuf), 0);
		if (iResult > 0)
		{
			recv_passed = true;
		}
	}

	if(recv_passed)
	{
		PrintReg("[*] WSASocket recv() PASSED!\n");
	}
	else
	{
		PrintError("[!] WSASocket send() Failed");
	}

	//Listen section
	proceed = false;

	ListenSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if(ListenSocket == INVALID_SOCKET)
	{
		PrintError("Error at socket(): %ld\n");
		proceed = false;
	}
	else 
	{
		proceed = true;
	}

	service.sin_family = AF_INET;
	service.sin_addr.s_addr = inet_addr("0.0.0.0");
	service.sin_port = htons(31337);

	if(proceed)
	{
		if(bind(ListenSocket, (SOCKADDR*)&service, sizeof(service)) == SOCKET_ERROR)
		{
			PrintError("[!] WSASocket bind() Failed");
			proceed = false;
		}
		else
		{
			PrintReg("[*] WSASocket bind() PASSED!\n");
			proceed = true;
		}
	}

	if(proceed)
	{
		if(listen(ListenSocket, SOMAXCONN) == SOCKET_ERROR)
		{
			listen_passed = false;
		}
		else
		{
			//this should produce a warning in windows 7
			listen_passed = true;
		}
	}

	if(listen_passed)
	{
		PrintReg("[*] WSASocket listen() PASSED!\n");
	}
	else
	{
		PrintError("[!] WSASocket bind() Failed");
	}
	
	closesocket(ListenSocket);
	closesocket(ConnectSocket);
	WSACleanup();

	//Test 5: Read/Write to clipboard
	char *buffer;
	HGLOBAL clipbuffer;
	HANDLE hClipData;
	HWND hwndMain = GetForegroundWindow();
	HANDLE retHandle = NULL;
	if(OpenClipboard(hwndMain))
	{
		EmptyClipboard();
		clipbuffer = GlobalAlloc(GMEM_DDESHARE, 0x20);
		buffer = (char*)GlobalLock(clipbuffer);
		strcpy(buffer, LPCSTR("Test Clipboard Data"));
		GlobalUnlock(clipbuffer);
		retHandle = SetClipboardData(CF_TEXT, clipbuffer);
		if(retHandle == NULL) 
		{
			PrintError("[!] SetClipboardData Failed");
		}
		else
		{
			PrintReg("[*] SetClipboardData PASSED!\n");
		}
		CloseClipboard();
	}

	retHandle = NULL;
	if(OpenClipboard(hwndMain))
	{
		hClipData = GetClipboardData(CF_TEXT);
		if(hClipData == NULL) 
		{
			PrintError("[!] GetClipboardData Failed");
		}
		else
		{
			PrintReg("[*] GetClipboardData PASSED!\n");
		}
		buffer = (char*)GlobalLock(hClipData);
		//PrintReg("Clipboard Data %s\n", buffer);
		GlobalUnlock(hClipData);
		CloseClipboard();
	}

	//Test 6: Read/Write from the Global Atom Table
	ATOM test_atom = 0;
	test_atom = GlobalAddAtom( (LPCWSTR) "GlobalAtomTest");
	if(test_atom == 0)
	{
		PrintError("[!] GlobalAddAtom Failed");
	}
	else
	{
		PrintReg("[*] GlobalAddAtom PASSED!\n");
	}

	test_atom = 0;
	test_atom = GlobalFindAtom((LPCWSTR) "GlobalAtomTest");
	if(test_atom == 0)
	{
		PrintError("[!] GlobalFindAtom Failed");
	}
	else
	{
		PrintReg("[*] GlobalFindAtom PASSED!\n");
	}

	////Test 7: Create/Switch Desktop
	HDESK new_desktop = NULL;
	new_desktop = CreateDesktop(LPCWSTR("ChrisDesktop"), NULL, NULL, 0x0, GENERIC_ALL, NULL);
	if(new_desktop == NULL)
	{
		PrintError("[!] CreateDesktop Failed");
	}
	else
	{
		PrintReg("[*] CreateDesktop PASSED!\n");
	}

	if(SwitchDesktop(new_desktop) == 0)
	{
		PrintError("[!] SwitchDesktop Failed");
	}
	else
	{
		PrintReg("[*] SwitchDesktop PASSED!\n");
	}
	CloseDesktop(new_desktop);

	////Test 8: Read/Write HKLM";
	DWORD BYTEINCREMENT = 4096;
	DWORD CURRSIZE = 1024;
	DWORD dwRet;
	DWORD cbData = CURRSIZE;
	char *key_data = NULL;

	//these will need to be changed based on the current registry values of your machine


	WCHAR *hklm_valuename = L"Chris";
	char *hkcu_valuename = "DAEMON Tools Lite";

	key_data = (char*)malloc(CURRSIZE);
//	dwRet = RegGetValue(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", L"ChrisTest", RRF_RT_ANY, NULL, (PVOID)key_data, &cbData); 

	unsigned long type=REG_SZ, size=1024;
	HKEY key;
	RegOpenKeyEx(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", NULL, KEY_READ, &key);

	dwRet = RegQueryValueEx( key,
                             L"ChrisTest",
                             NULL,
                             &type,
                             (LPBYTE) &key_data[0],
                             &cbData );


	if(dwRet != ERROR_SUCCESS)
	{
		PrintError("[!] RegGetValueW(HKEY_LOCAL_MACHINE) Failed:");
	}
	else
	{
		PrintReg("[*] RegGetValueW(HKEY_LOCAL_MACHINE) PASSED! [%s]\n");
	}

	free(key_data);

	key_data = (char*)malloc(CURRSIZE);
	cbData = CURRSIZE;
//	dwRet = RegGetValue(HKEY_CURRENT_USER, L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", L"ChrisTest", RRF_RT_ANY, NULL, (PVOID)key_data, &cbData); 

	type=REG_SZ, size=1024;

	RegOpenKeyEx(HKEY_CURRENT_USER, L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", NULL, KEY_READ, &key);

	dwRet = RegQueryValueEx( key,
                             L"ChrisTest",
                             NULL,
                             &type,
                             (LPBYTE) &key_data[0],
                             &cbData );

	if(dwRet != ERROR_SUCCESS)
	{
		PrintError("[!] RegGetValueW(HKEY_LOCAL_MACHINE) Failed:");
	}
	else
	{
		PrintReg("[*] RegGetValueW(HKEY_LOCAL_MACHINE) PASSED! [%s]\n");
	}

	free(key_data);



	//Test 9: Read/Write SystemParamentersInfo()
	int aMouseInfo[3];
	BOOL fResult;

	fResult = SystemParametersInfo(SPI_GETMOUSE, 0, &aMouseInfo, 0);
	if(fResult == 0)
	{
		PrintError("[!] Get SystemParametersInfo Failed");
		PrintError("[!] Set SystemParametersInfo Failed");
	}
	else
	{
		PrintReg("[*] Get SystemParametersInfo PASSED!\n");

		int old_mouse_speed = aMouseInfo[2];
		aMouseInfo[2] = 2 * old_mouse_speed;
		fResult = SystemParametersInfo(SPI_SETMOUSE, 0, &aMouseInfo, SPIF_SENDCHANGE);
		if(fResult == 0)
		{
			PrintError("[!] Set SystemParametersInfo Failed");
		}
		else
		{
			PrintReg("[*] Set SystemParametersInfo PASSED!\n");
			aMouseInfo[2] = old_mouse_speed;
			SystemParametersInfo(SPI_SETMOUSE, 0, &aMouseInfo, SPIF_SENDCHANGE);

		}
	}

	//Test 10: Windows Message Broadcast
	LPCTSTR strMsg = TEXT("Message to be Sent");
	DWORD err_val;
	SendMessage(HWND_BROADCAST , WM_SETTEXT, 0, (LPARAM)strMsg);

	err_val = GetLastError();

	if(err_val == ERROR_ACCESS_DENIED)
	{
		PrintError("[!] SendMessage Broadcast Failed");
	}
	else
	{
		PrintReg("[*] SendMessage Broadcast PASSED!\n");
	}



	//Test 11: Set Windows Hooks
	typedef int (__stdcall *MYPROC)(HWND a, LPCSTR b, LPCSTR c, INT d); 
	HINSTANCE hinstLib;
	//MYPROC ProcMsg;
	static HHOOK hhookSysMsg;
	HOOKPROC hkprcSysMsg;

	hinstLib = LoadLibrary(TEXT("User32"));
	if(hinstLib != NULL)
	{
		hkprcSysMsg = (HOOKPROC)GetProcAddress(hinstLib, "MessageBoxA");
		if(hkprcSysMsg != NULL)
		{
			hhookSysMsg = SetWindowsHookEx(WH_DEBUG, hkprcSysMsg, hinstLib, 0);
			if(hhookSysMsg != NULL)
			{
				PrintReg("[*] SetWindowsHookEx PASSED!\n");
				UnhookWindowsHookEx(hhookSysMsg);
			}
			else
			{
				PrintError("[!] SetWindowsHookEx Failed");
			}
		}
		else
		{
			PrintError("[!] GetProcessAddress Failed");
		}
		FreeLibrary(hinstLib);
	}
	else
	{
		PrintError("[!] LoadLibrary Failed");
	}
	*/
//	fclose(f);
//	Sleep(10000);
}


// CMyActiveXCtrl::OnDraw - Drawing function

void CMyActiveXCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{

	f = fopen("C:\\Users\\Charlie\\Desktop\\foo.txt", "w+");
	fwrite("hi", 1, 2, f);
	fclose(f);

	if (!pdc)
		return;

	charlie();

	DoSuperclassPaint(pdc, rcBounds);
}



// CMyActiveXCtrl::DoPropExchange - Persistence support

void CMyActiveXCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
}



// CMyActiveXCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
DWORD CMyActiveXCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();


	// The control will not be redrawn when making the transition
	// between the active and inactivate state.
	dwFlags |= noFlickerActivate;
	return dwFlags;
}



// CMyActiveXCtrl::OnResetState - Reset control to default state

void CMyActiveXCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}



// CMyActiveXCtrl::PreCreateWindow - Modify parameters for CreateWindowEx

BOOL CMyActiveXCtrl::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.lpszClass = _T("STATIC");
	return COleControl::PreCreateWindow(cs);
}



// CMyActiveXCtrl::IsSubclassedControl - This is a subclassed control

BOOL CMyActiveXCtrl::IsSubclassedControl()
{
	return TRUE;
}



// CMyActiveXCtrl::OnOcmCommand - Handle command messages

LRESULT CMyActiveXCtrl::OnOcmCommand(WPARAM wParam, LPARAM lParam)
{
#ifdef _WIN32
	WORD wNotifyCode = HIWORD(wParam);
#else
	WORD wNotifyCode = HIWORD(lParam);
#endif

	// TODO: Switch on wNotifyCode here.

	return 0;
}


CMyActiveXCtrl::CMyActiveXCtrl()
{
	InitializeIIDs(&IID_DMyActiveX, &IID_DMyActiveXEvents);
	// TODO: Initialize your control's instance data here.
	charlie();



}


// CMyActiveXCtrl message handlers
