#!/usr/bin/env ruby

require 'csv'

require 'mysql'
$db = Mysql::new("localhost", "root", "", "browsers")

def set_report_date(bug, date)
	qry = "update vulns set report_date='#{date.to_s}' where prod_id='3' and vendor_id='#{bug}'"
	$db.query(qry)
end

CSV.foreach('from-justin/chromium-issues.csv') { |row|
	next if row.length < 1
	next if row[0] == "ID" # header row

	#puts row.inspect
	bug = row[0]

	title = row[1]

	# row[2] is the labels, it requires some more parsing
	labels = row[2]

	milestone = row[3]

	# dates..
	date1 = DateTime.parse(row[4])
	date2 = DateTime.parse(Time.at(row[5].to_i).to_s)
	#puts "DATES: " + date1.inspect + " / " + date2.inspect
	raise 'ugh' if date1 != date2

	cve = row[6]

	set_report_date(bug.to_i, date1.to_s)
}

# These are not in the CSV, but are open/accessible bugs
set_report_date(3275, '2008-10-09')
set_report_date(8864, '2009-03-17')
set_report_date(24701, '2009-10-13')

set_report_date(12303, '2009-05-19')
set_report_date(29914, '2009-12-09')

set_report_date(30801, '2009-12-18')

set_report_date(54006, '2010-08-31')

set_report_date(65669, '2010-12-06')
