#!/usr/bin/env ruby

require 'csv'

require 'mysql'
$db = Mysql::new("localhost", "root", "", "browsers")


if ARGV.length < 1
	$stderr.puts "usage: csv_query <sql query> [<output file>]"
	exit(1)
end

query = ARGV.shift

output_file = nil
output_file = ARGV.shift if ARGV.length > 0
if output_file
	raise 'file exists' if File.exists? output_file
	csv = CSV.open(output_file, "w")
else
	csv = CSV.new($stdout)
end

res = $db.query(query)

res.each { |row|
  csv << row
}

csv.close
