class CreateVulns < ActiveRecord::Migration
  def self.up
    create_table :vulns do |t|
		t.string :prod_id
      t.string :title
      t.string :vendor_id
      t.string :cve
      t.string :severity
      t.date :report_date
      t.date :discover_date
      t.date :disclosure_date

		t.references :advisory

      t.timestamps
    end
  end

  def self.down
    drop_table :vulns
  end
end
